from ConfigParser import ConfigParser


#
# Reader for .desktop files.
#
class DesktopReader:

    __SECTION = "Desktop Entry"
    __ENTRY_COMMENT = "Comment"
    __ENTRY_EXEC = "Exec"
    __ENTRY_ICON = "Icon"
    __ENTRY_NAME = "Name"
    __ENTRY_TYPE = "Type"


    def __init__(self, filename):

        self.__parser = None

        self.__parse(filename)
    


    def __parse(self, filename):

        self.__parser = ConfigParser()
        self.__parser.read(filename)

        entries = self.__parser.options(self.__SECTION)



    def get_comment(self, language = ""):

        if (language): key = self.__ENTRY_COMMENT + "[" + language + "]"
        else: key = self.__ENTRY_COMMENT
        
        return self.__parser.get(self.__SECTION, key)



    def get_exec(self):

        return self.__parser.get(self.__SECTION, self.__ENTRY_EXEC)



    def get_icon(self):

        return self.__parser.get(self.__SECTION, self.__ENTRY_ICON)



    def get_name(self, language = ""):

        if (language): key = self.__ENTRY_NAME + "[" + language + "]"
        else: key = self.__ENTRY_NAME

        return self.__parser.get(self.__SECTION, key)



    def get_type(self):

        return self.__parser.get(self.__SECTION, self.__ENTRY_TYPE)
