from DesktopReader import DesktopReader

import os
import commands


class Icon:

    # the pixmap directory of GNOME
    __GNOME_PIXMAP_DIR = \
      os.path.join(
        commands.getoutput("dirname `which gnome-desktop-item-edit`"),
        "..", "share", "pixmaps")

    # the unknown icon
    __UNKNOWN_ICON = "gnome-unknown.png"


    def __init__(self, desktopfile):

        self.__zoom_level = 1.0
        self.__command = ""
        self.__pixmap = ""

        self.__load_icon(desktopfile)



    #
    # Loads the given icon.
    #
    def __load_icon(self, desktopfile):
        
        reader = DesktopReader(desktopfile)
        try:
            iconname = reader.get_icon()
            self.__pixmap = self.__get_icon_path(iconname)
        except:
            self.__pixmap = self.__get_icon_path(" ")
        self.__command = reader.get_exec()

    


    #
    # Returns the full path of the given icon.
    #
    def __get_icon_path(self, icon):

        if (icon and icon[0] == "/"): return icon
        
        files = os.listdir(self.__GNOME_PIXMAP_DIR)
        for f in files:
            if (f.startswith(icon)):
                return os.path.join(self.__GNOME_PIXMAP_DIR, f)
        #end for

        return os.path.join(self.__GNOME_PIXMAP_DIR, self.__UNKNOWN_ICON)



    def get_pixmap(self): return self.__pixmap

    def set_zoom(self, zoom): self.__zoom_level = zoom
    def get_zoom(self): return self.__zoom_level

    def get_command(self): return self.__command
